stages:
  - greetings
  - calculate

include: "/javascript.gitlab-ci.yml"

# helpers - yaml anchors
.my-helpers: &my-helpers |
  function add() {
    addition=$(expr ${1} + ${2})
    echo "addition ${addition}" > addition.txt
  }

  function substract() {
    substraction=$(expr ${1} - ${2})
    echo "substraction ${substraction}" > substraction.txt
  }

  function divide() {
    division=$(expr ${1} / ${2})
    echo "division ${division}" > division.txt
  }

# a module with variables
.ruby_code_snippets:
  variables:
    ruby_01: |
      require 'json'

      hello = {
        :message => "👋 Hello World 🌍"
      }
      puts JSON.generate(hello)

      file = File.open("message.json", "w")
      file.write hello.to_json

    ruby_02: |
      file = File.open("message.txt", "w")
      file.write "🇫🇷 👋 Salut à tous 😃"

# a module with a script
.run_ruby:
  script: |
    ruby -e "${ruby}"



# use the default image
.hello:
  stage: greetings
  script: 
    - echo "hello 👋"


# use another image
.hey:
  image: node:slim
  stage: greetings
  variables:
    javascript: |
      let a = 40
      let b = 2
      let c = a + b
      console.log("🚀", c)
  script: |
    node -e "${javascript}" 

mathematics:
  stage: calculate
  script:
    - *my-helpers
    - add 10 32
    - substract 44 2
    - divide 84 2
    - cat addition.txt
    - cat substraction.txt
    - cat division.txt
  artifacts:
    paths:
      - ./*.txt
    expire_in: 1 week

# use it with extends
js:hello:
  stage: greetings
  extends: .run_javascript
  variables:
    javascript: |
      const fs = require("fs")
      fs.writeFileSync(`./hello.txt`, "👋 hello world 🌍")
  artifacts:
    paths:
      - ./hello.txt


# use it
rb:hello:
  image: ruby:slim
  stage: greetings
  variables: 
    #ruby: !reference [.ruby_code_snippets, variables, ruby_01]
    ruby: !reference [.ruby_code_snippets, variables, ruby_02]
  script:
    - !reference [.run_ruby, script]
    - echo "${MESSAGE}"
  artifacts:
    paths:
      - ./message.*

